"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Transformer = function () {
    function Transformer(_ref) {
        var _ref$transformers = _ref.transformers,
            transformers = _ref$transformers === undefined ? [] : _ref$transformers,
            _ref$marker = _ref.marker,
            marker = _ref$marker === undefined ? "_pjson" : _ref$marker;

        _classCallCheck(this, Transformer);

        this.transformers = transformers;
        this.marker = marker;
    }

    _createClass(Transformer, [{
        key: "encode",
        value: function encode(data) {
            var _this = this;

            for (var i = 0; i < this.transformers.length; i += 1) {

                var transformer = this.transformers[i];

                if (transformer.test(data)) return _defineProperty({ value: transformer.encode(data) }, this.marker, i + 1);
            }

            if (data instanceof Array) return data.map(function (x) {
                return _this.encode(x);
            });

            if (data instanceof Object) {

                var results = {};
                var _iteratorNormalCompletion = true;
                var _didIteratorError = false;
                var _iteratorError = undefined;

                try {
                    for (var _iterator = Object.keys(data)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                        var key = _step.value;

                        results[key] = this.encode(data[key]);
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }
                    } finally {
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }

                return results;
            }

            return data;
        }
    }, {
        key: "decode",
        value: function decode(data) {
            var _this2 = this;

            if (data instanceof Object && data[this.marker]) {
                return this.transformers[data[this.marker] - 1].decode(data.value);
            }

            if (data instanceof Array) return data.map(function (x) {
                return _this2.decode(x);
            });

            if (data instanceof Object) {

                var results = {};
                var _iteratorNormalCompletion2 = true;
                var _didIteratorError2 = false;
                var _iteratorError2 = undefined;

                try {
                    for (var _iterator2 = Object.keys(data)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                        var key = _step2.value;

                        results[key] = this.decode(data[key]);
                    }
                } catch (err) {
                    _didIteratorError2 = true;
                    _iteratorError2 = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion2 && _iterator2.return) {
                            _iterator2.return();
                        }
                    } finally {
                        if (_didIteratorError2) {
                            throw _iteratorError2;
                        }
                    }
                }

                return results;
            }

            return data;
        }
    }]);

    return Transformer;
}();

module.exports = Transformer;