
class Transformer {

    constructor( { transformers = [], marker = "_pjson" } ) {

        this.transformers = transformers;
        this.marker       = marker;

    }

    encode( data ) {

        for( var i = 0; i < this.transformers.length; i+= 1 ) {

            var transformer = this.transformers[ i ];

            if( transformer.test( data ) ) 
                return { value : transformer.encode( data ), [ this.marker ] : i + 1 };

        }

        if( data instanceof Array )
            return data.map( x => this.encode( x ) );

        if( data instanceof Object ) {

            var results = {};
            for( var key of Object.keys( data ) )
                results[ key ] = this.encode( data[ key ] );
            return results;

        }

        return data;
            
    }

    decode( data ) {

        if( data instanceof Object && data[ this.marker ] )  {
            return this.transformers[ data[ this.marker ] - 1 ].decode( data.value );
        }

        if( data instanceof Array )
            return data.map( x => this.decode( x ) );

        if( data instanceof Object ) {

            var results = {};
            for( var key of Object.keys( data ) )
                results[ key ] = this.decode( data[ key ] );
            return results;

        }

        return data;

    }

}

module.exports = Transformer;
